<?php

namespace Drupal\vrssfa\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriberViewsrssFeed extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {

    // Get RSS Feed URLs list.
    $config_data = \Drupal::config('views_rss_authentication.settings')->get('view_rss_feed_url');
    // Get current path of the page.
    $current_path = \Drupal::service('path.current')->getPath();
    // Get selected authentication type.
    $authentication_type = \Drupal::config('views_rss_authentication.settings')->get('authentication_type');

    if ($config_data) {
      $urls = explode(PHP_EOL, $config_data);
      foreach ($urls as $url) {
        // Get route name by its path.
        $route_provider = \Drupal::service('router.route_provider');
        $found_routes = $route_provider->getRoutesByPattern($url);
        $route_names = [];
        foreach ($found_routes as $route_name => $route_object) {
          $route_names[] = $route_name;
        }
        if ($route = $collection->get($route_names[0])) {
          $route->setOption('_auth', array($authentication_type));
          $route->setRequirement('_user_is_logged_in', 'TRUE');
          $collection->add(($route_names[0]), $route);
        }
      }
    }
 }

}
